package cmd

import (
	"bitbucket.org/orus-io/xbus/fullenv_tests"
	"github.com/spf13/cobra"
)

var setupCmd = &cobra.Command{
	Use:   "setup",
	Short: "Setup a fullenv directory",
	Run:   xbusFullenvSetup,
}

func xbusFullenvSetup(cmd *cobra.Command, args []string) {
	if len(args) != 1 {
		cmd.Usage()
		return
	}

	basename, options, err := loadOptions(cmd, args[0])
	if err != nil {
		return
	}

	options.NoDBLock = true

	env := fullenv.NewFullEnv(basename, options)

	if err := env.Init(); err != nil {
		Logger.Errorf("Could not init env: %s", err)
		return
	}

	env.Close()
}

func init() {
	RootCmd.AddCommand(setupCmd)
}
