package fullenv

import (
	"testing"
	"time"
)

// TestFlood sends a lot of small messages in a minimum of time, and see if
// nothing fails
func TestFlood(t *testing.T) {
	env, _ := NewFullEnvForTest(t, "flood", "flood.yaml")

	if err := env.Init(); err != nil {
		t.Fatal(err)
	}

	defer env.Close()
	cr := NewCounterReceiver(t, 2000)
	env.RegisterActorService("test.receivecounter", cr.Service)

	if err := env.Startup(); err != nil {
		t.Fatal(err)
	}

	t.Log("Waiting for completion")
	select {
	case <-cr.receivedAll:
		t.Log("Everything's alright")
		// Wait for the consumer to properly reply to the server.
		// TODO Dig into this and fix it. The consumer should not be able to
		// stop before the reply was sent (I think its already the case but
		// it needs verification).
		time.Sleep(1 * time.Second)
	case <-time.After(420 * time.Second):
		t.Errorf("Reception timeout")
		t.Errorf("Next number expected: %d", cr.nextExpected)
		t.Errorf("Missing numbers: %v", cr.missingnumbers)
	}
}
